unit UMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList, DB, ADODB, StdCtrls, ExtCtrls, Buttons, CheckLst,
  ComCtrls, OleCtrls, SHDocVw, ToolWin, Menus, INIFiles, ImgList, Spin,RichEdit;


  //uses REAbout, RichEdit, ShellAPI, ReInit;

type
  TForm1 = class(TForm)
    ActionList1: TActionList;
    ADO1: TADOConnection;
    AConnStr: TAction;
    AAspGen: TAction;
    Tbl1: TADOTable;
    SaveDialog1: TSaveDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    WebBrowser1: TWebBrowser;
    StatusBar1: TStatusBar;
    ToolBar1: TToolBar;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Esci1: TMenuItem;
    AApriImp: TAction;
    ASalvaImp: TAction;
    VAGOpen: TOpenDialog;
    VAGSave: TSaveDialog;
    ImageList1: TImageList;
    ApriFileImpostazioni1: TMenuItem;
    N1: TMenuItem;
    ToolButton1: TToolButton;
    ANewImp: TAction;
    NuovoFileImpostazioni1: TMenuItem;
    SalvaFileImpostazioni1: TMenuItem;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ASavASP: TAction;
    Run1: TMenuItem;
    Connetti1: TMenuItem;
    GeneraASP1: TMenuItem;
    SalvaASP1: TMenuItem;
    N2: TMenuItem;
    About1: TMenuItem;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    CoolBar1: TCoolBar;
    ToolBar2: TToolBar;
    StopBtn: TToolButton;
    ATestPage: TAction;
    N3: TMenuItem;
    SaveASP1: TMenuItem;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    AOption: TAction;
    ools1: TMenuItem;
    Options1: TMenuItem;
    ToolButton10: TToolButton;
    TabSheet3: TTabSheet;
    Panel1: TPanel;
    EConnStr: TLabeledEdit;
    BitBtn1: TBitBtn;
    Label3: TLabel;
    Panel3: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    SBUp: TSpeedButton;
    SBDown: TSpeedButton;
    LInfo: TLabel;
    Label4: TLabel;
    EListType: TListBox;
    EListTbl: TListBox;
    EListField: TCheckListBox;
    EListIndex: TListBox;
    Panel4: TPanel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    Memo1: TRichEdit;
    SpeedButton1: TSpeedButton;
    ABuildCS: TAction;
    TabSheet4: TTabSheet;
    Panel5: TPanel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    SpeedButton3: TSpeedButton;
    Edit2: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label15: TLabel;
    Edit1: TEdit;
    Label16: TLabel;
    Label17: TLabel;
    procedure UpdateCursorPos;
    procedure GenInit;
    procedure GenSearchForm;
    procedure GenNewForm;
    procedure GenSubInsert;
    procedure GenEditForm;
    procedure GenSubUpdate;
    procedure GenSubDelete;
    procedure GenRetreiveData;
    procedure GenNavigator;
    procedure GenDisplayData;
    procedure GenMain;
    procedure leggiIni(nomefile:string);
    procedure scriviIni(nomefile:string);
    procedure AConnStrExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure AAspGenExecute(Sender: TObject);
    procedure EListTblClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Esci1Click(Sender: TObject);
    procedure AApriImpExecute(Sender: TObject);
    procedure ASalvaImpExecute(Sender: TObject);
    procedure ANewImpExecute(Sender: TObject);
    procedure ADO1AfterDisconnect(Sender: TObject);
    procedure ADO1AfterConnect(Sender: TObject);
    procedure ASavASPExecute(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure StopActionExecute(Sender: TObject);
    procedure WebBrowser1DownloadBegin(Sender: TObject);
    procedure WebBrowser1DownloadComplete(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure ATestPageExecute(Sender: TObject);
    procedure AOptionExecute(Sender: TObject);
    procedure Memo2Change(Sender: TObject);
    procedure SBUpClick(Sender: TObject);
    procedure SBDownClick(Sender: TObject);
    procedure Memo1SelectionChange(Sender: TObject);
    procedure ABuildCSExecute(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const versione='1.2';

resourcestring
  sColRowInfo = 'Line: %3d   Col: %3d';


var
  Form1: TForm1;

implementation

uses UAbout, UAdoVbs, UOption, UInfoPrj, UBuildCS;

{$R *.dfm}

procedure TForm1.AConnStrExecute(Sender: TObject);
begin
  screen.Cursor:=crhourglass;
  ado1.Connected:=false;
  ado1.ConnectionString:=econnstr.Text;
  ado1.Connected:=true;
  ado1.GetTableNames(EListTbl.Items);
  EListTbl.Enabled:=ado1.Connected;
  EListField.Enabled:=ado1.Connected;
  FOption.EOpzioni.Enabled:=ado1.Connected;
  activecontrol:=EListTbl;
  screen.Cursor:=crdefault;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ado1.Connected:=false;
end;


procedure TForm1.GenInit;
begin
    with memo1.Lines do
    begin
      Add('<!--Generated with VAspGen V.'+versione+'-->');
      Add('<HTML>');
      add('<head><TITLE>'+elisttbl.Items[elisttbl.itemindex]+'</TITLE>');
      add('<script language="JavaScript">');
      add('function SbmForm(OrderField,OrderDesc,NumPage) {');
      add('  document.QUERY.ORDINAMENTO.value = OrderField;');
      add('  document.QUERY.ORDDESC.value = OrderDesc;');
      add('  document.QUERY.PN.value = NumPage;');
      add('  document.QUERY.submit();');
      add('  return true;');
      add('}');
      add('</script>');
      if FOption.essi1.Text<>'' then add('<!--#include virtual="'+ FOption.essi1.Text+'" -->');
      if FOption.essi2.Text<>'' then add('<!--#include virtual="'+ FOption.essi2.Text+'" -->');
      if FOption.essi3.Text<>'' then add('<!--#include virtual="'+ FOption.essi3.Text+'" -->');
      if FOption.essi4.Text<>'' then add('<!--#include virtual="'+ FOption.essi4.Text+'" -->');
      Add('<%');
      add('''------------------------------------------------------------------------------------------------------------------''');
      add('Function OpenDataBase()');
      add('  Dim DB');
      add('  Set DB = Server.CreateObject("ADODB.Connection")');
      add('  DB.ConnectionString = "'+ econnstr.Text +'"');
      add('  DB.Open');
      add('  Set OpenDataBase = DB');
      add('End Function');
      add('''------------------------------------------------------------------------------------------------------------------''');

      add('''------------------------------------------------------------------------------------------------------------------''');
      add('Function PrepareField(campo)');
      add('  PrepareField=replace(campo,"''","''''")');
      add('End Function');
      add('''------------------------------------------------------------------------------------------------------------------''');
      add('''------------------------------------------------------------------------------------------------------------------''');
      add('function FlipRowStyle(IsOdd, clsOdd, clsPair)');
      add('  IsOdd = not IsOdd');
      add('  if IsOdd then');
      add('    FlipRowStyle = "BACKGROUND-COLOR:#'+foption.EPairColor.Text+';color: black;"');
      add('  else');
      add('    FlipRowStyle = "BACKGROUND-COLOR:#'+foption.EOddColor.text+';color: black;"');
      add('  end if');
      add('end function');
      add('''------------------------------------------------------------------------------------------------------------------''');
    end;
end;


procedure TForm1.GenSearchForm;
var t:integer;
    s:string;
begin
  with memo1.Lines do
  begin
    add('''------------------------------------------------------------------------------------------------------------------''');

    s:='Sub Intestazione(db,pn,ordinamento,orddesc,R_'+EListField.Items[0];
    for t:=1 to EListField.Items.Count-1 do
    begin
      s:=s+', R_'+EListField.Items[t];
    end;
    s:=s+',nrecpp,CB_'+EListField.Items[0];
    for t:=1 to EListField.Items.Count-1 do
    begin
      s:=s+', CB_'+EListField.Items[t];
    end;
    s:=s+')';
    add(s);


    add('  response.write "<FORM NAME=""QUERY"" ID=""QUERY"" ACTION="""& request.servervariables("PATH_INFO") &""" METHOD=""post"">" & vbCRLF');
    add('  response.write "<INPUT TYPE=""HIDDEN"" NAME=""PN"" VALUE=""" & pn & """>" & vbCRLF');
    add('  response.write "<INPUT TYPE=""HIDDEN"" NAME=""ORDINAMENTO"" VALUE=""" & ordinamento & """>" & vbCRLF');
    add('  response.write "<INPUT TYPE=""HIDDEN"" NAME=""ORDDESC"" VALUE=""" & orddesc & """>" & vbCRLF');

    s:='  response.write "<table';
    if FOption.ebordo.Checked then s:=s+' border=1 cellspacing='+FOption.ECellspacing.Text+' cellpadding='+FOption.ECellpadding.Text;
    s:=s+'>" & vbCRLF';
    add(s);
    for t:=1 to EListField.Items.Count-1 do
    begin
      if t mod 2 = 1 then add('  response.write "<tr>" & vbCRLF');
      //s:=s+', '+EListField.Items[t];
      S:='  response.write "<th align=""right"">'+EListField.Items[t]+'<input type=checkbox name=""CB_'+EListField.Items[t]+'"" value=Y"';
      add(s);
      //if elistfield.Checked[t] then s:=s+' checked';
      add('  if CB_'+EListField.Items[t]+'="Y" then response.write " checked "');
      s:='  response.write "></th><td><INPUT TYPE=""text"" NAME=""R_'+EListField.Items[t]+'"" VALUE=""" & R_'+EListField.Items[t]+' & """></td>" & vbCRLF';
      add(s);
      //add('	response.write "<th align=""right"">'+EListField.Items[t]+'</th><td><input type=checkbox name=""CB_'+EListField.Items[t]+'"" value=Y><INPUT TYPE=""text"" NAME=""R_'+EListField.Items[t]+'"" VALUE=""" & R_'+EListField.Items[t]+' & """></td>" & vbCRLF');
      if t mod 2 = 0 then add('  response.write "</tr>" & vbCRLF');
    end;
    add('  response.write "<tr>" & vbCRLF');
    add('  response.write "<td align=right colspan=4>Num. rec. per pagina <INPUT TYPE=""text"" NAME=""nrecpp"" SIZE=""5"" VALUE=""" & nrecpp & """><INPUT TYPE=hidden NAME=searchok VALUE=Y><INPUT TYPE=""submit"" value=""OK""></td>" & vbCRLF');
    add('  response.write "</tr>" & vbCRLF');
    add('  response.write "</table>" & vbCRLF');
    add('  response.write "</form>" & vbCRLF');
    add('End Sub');
    add('''------------------------------------------------------------------------------------------------------------------''');
  end;
end;

procedure TForm1.GenNewForm;
var t:integer;
    s:string;
begin
  with memo1.Lines do
  begin
      add('''------------------------------------------------------------------------------------------------------------------''');
      add('Sub Form_Nuovo()');
      add('  response.write "<FORM ACTION=""" & request.servervariables("PATH_INFO") & """ METHOD=""post"">" & vbCRLF');

      s:='  response.write "<table';
      if FOption.ebordo.Checked then s:=s+' border=1 cellspacing='+FOption.ECellspacing.Text+' cellpadding='+FOption.ECellpadding.Text;
      s:=s+'>" & vbCRLF';
      add(s);

      for t:=1 to EListField.Items.Count-1 do
      begin
        add('  response.write "<tr>" & vbCRLF');
        s:=s+', '+EListField.Items[t];
        add('  response.write "<th align=""right"">'+EListField.Items[t]+'</th><td><INPUT TYPE=""text"" NAME=""N_'+EListField.Items[t]+'""></td>" & vbCRLF');
        add('  response.write "</tr>" & vbCRLF');
      end;
      add('  response.write "<tr>" & vbCRLF');
      add('  response.write "<td align=right colspan=2><INPUT TYPE=""hidden"" NAME=""nuovoi"" VALUE=""yes""><INPUT TYPE=""submit"" value=""OK""></td>" & vbCRLF');
      add('  response.write "</tr>" & vbCRLF');
      add('  response.write "</table>" & vbCRLF');
      add('  response.write "</form>" & vbCRLF');
      add('  response.write "</center>" & vbCRLF');
      add('End Sub');
      add('''------------------------------------------------------------------------------------------------------------------''');
  end;
end;


procedure TForm1.GenSubInsert;
var t:integer;
    s:string;
begin
  with memo1.Lines do
  begin
      add('''------------------------------------------------------------------------------------------------------------------''');
      s:='Sub SubInsert(db,N_'+EListField.Items[0];
      for t:=1 to EListField.Items.Count-1 do
      begin
        s:=s+', N_'+EListField.Items[t];
      end;
      s:=s+')';
      add(s);
      s:='  sqltext = "insert into '+elisttbl.Items[elisttbl.itemindex]+'('+EListField.Items[1];
      for t:=2 to EListField.Items.Count-1 do
      begin
        s:=s+', '+EListField.Items[t];
      end;
      s:=s+')"';
      add(s);

      if (pos('string',elisttype.Items[1])>0) then s:='  sqltext = sqltext & " values(''" & PrepareField(N_'+EListField.Items[1]+') & "'''
                                              else s:='  sqltext = sqltext & " values(" & N_'+EListField.Items[1]+' & "';
      for t:=2 to EListField.Items.Count-1 do
      begin
      if (pos('string',elisttype.Items[t])>0) then s:=s+', ''" & PrepareField(N_'+EListField.Items[t]+') & "'''
                                              else s:=s+', " & N_'+EListField.Items[t]+' & "';
      end;
      s:=s+')"';
      add(s);
      add('  db.execute(sqltext)');
      add('  if err.number<>0 then response.write "ERRORE n." & err.number & "<br>" & err.description & "<br>SQL Error<br> " & sqltext');
      add('  response.redirect request.servervariables("PATH_INFO")');
      add('End Sub');
      add('''------------------------------------------------------------------------------------------------------------------''');
  end;
end;

procedure TForm1.GenEditForm;
var t:integer;
    s:string;
begin
  with memo1.Lines do
  begin
      add('''------------------------------------------------------------------------------------------------------------------''');
      add('Sub Form_Edit(db, '+ EListField.Items[0] + ')');
      s:='  sqltext = "select '+EListField.Items[0];
      for t:=1 to EListField.Items.Count-1 do
      begin
        s:=s+', '+EListField.Items[t];
      end;
      s:=s+' from '+elisttbl.Items[elisttbl.itemindex]+' where ' + EListField.Items[0] + '=" & ' + EListField.Items[0];
      add(s);
      add('  set ds = db.execute(sqltext)');
      add('  if err.number<>0 then response.write "ERRORE n." & err.number & "<br>" & err.description & "<br>SQL Error<br> " & sqltext');


      add('  response.write "<FORM ACTION=""" & request.servervariables("PATH_INFO") & """ METHOD=""post"">" & vbCRLF');
      s:='  response.write "<table';
      if FOption.ebordo.Checked then s:=s+' border=1 cellspacing='+FOption.ECellspacing.Text+' cellpadding='+FOption.ECellpadding.Text;
      s:=s+'>" & vbCRLF';
      add(s);
      for t:=1 to EListField.Items.Count-1 do
      begin
        add('  response.write "<tr>" & vbCRLF');
        s:=s+', '+EListField.Items[t];
        add('  response.write "<th align=""right"">'+EListField.Items[t]+'</th><td><INPUT TYPE=""text"" NAME=""E_'+EListField.Items[t]+'"" VALUE=""" & ds("'+EListField.Items[t]+'") & """></td>" & vbCRLF');
        add('  response.write "</tr>" & vbCRLF');
      end;
      add('  response.write "<tr>" & vbCRLF');
      add('  response.write "<td align=right colspan=2><INPUT TYPE=""hidden"" NAME=""modificai"" VALUE=""yes""><INPUT TYPE=""submit"" value=""OK"">"');
      add('  response.write "<INPUT TYPE=""hidden"" NAME=""E_'+EListField.Items[0]+'"" VALUE=""" & ' +EListField.Items[0]+ ' & """></td>" & vbCRLF');
      add('  response.write "</tr>" & vbCRLF');
      add('  response.write "</table>" & vbCRLF');
      add('  response.write "</form>" & vbCRLF');
      add('  response.write "</center>" & vbCRLF');
      add('End Sub');
      add('''------------------------------------------------------------------------------------------------------------------''');
  end;
end;

procedure TForm1.GenSubUpdate;
var t:integer;
    s:string;
begin
  with memo1.Lines do
  begin
      add('''------------------------------------------------------------------------------------------------------------------''');
      s:='Sub SubUpdate(db,E_'+EListField.Items[0];
      for t:=1 to EListField.Items.Count-1 do
      begin
        s:=s+', E_'+EListField.Items[t];
      end;
      s:=s+')';
      add(s);
      s:='  sqltext = "update '+elisttbl.Items[elisttbl.itemindex]+' set ';
      if (pos('string',elisttype.Items[1])>0) then s:=s+EListField.Items[1]+'=''" & PrepareField(E_'+EListField.Items[1]+') & "'''
                                              else s:=s+EListField.Items[1]+'=" & E_'+EListField.Items[1]+' & "';
      for t:=2 to EListField.Items.Count-1 do
      begin
        if (pos('string',elisttype.Items[t])>0) then s:=s+', '+EListField.Items[t]+'=''" & PrepareField(E_'+EListField.Items[t]+') & "'''
                                                else s:=s+', '+EListField.Items[t]+'=" & E_'+EListField.Items[t]+' & "';
      end;
      s:=s+' where ' + EListField.Items[0] + '=" & E_' + EListField.Items[0];;
      add(s);
      add('  db.execute(sqltext)');
      add('  if err.number<>0 then response.write "ERRORE n." & err.number & "<br>" & err.description & "<br>SQL Error<br> " & sqltext');
      add('  response.redirect request.servervariables("PATH_INFO")');
      add('End Sub');
      add('''------------------------------------------------------------------------------------------------------------------''');
  end;
end;

procedure TForm1.GenSubDelete;
var t:integer;
    s:string;
begin
  with memo1.Lines do
  begin
      add('''------------------------------------------------------------------------------------------------------------------''');
      add('Sub SubDelete(db,'+EListField.Items[0]+')');
      add('  sqltext = "delete from '+elisttbl.Items[elisttbl.itemindex]+' where '+EListField.Items[0]+'=" & '+EListField.Items[0]);
      add('  db.execute(sqltext)');
      add('  if err.number<>0 then response.write "ERRORE n." & err.number & "<br>" & err.description & "<br>SQL Error<br> " & sqltext');
      add('  response.redirect request.servervariables("PATH_INFO")');
      add('End Sub');
      add('''------------------------------------------------------------------------------------------------------------------''');
  end;
end;

procedure TForm1.GenRetreiveData;
var t:integer;
    s:string;
begin
  with memo1.Lines do
  begin
      add('''------------------------------------------------------------------------------------------------------------------''');
      s:='Function RetreiveData(db, ordinamento, orddesc, R_'+EListField.Items[0];
      for t:=1 to EListField.Items.Count-1 do
      begin
        s:=s+', R_'+EListField.Items[t];
      end;
      s:=s+',nrecpp,CB_'+EListField.Items[0];
      for t:=1 to EListField.Items.Count-1 do
      begin
        s:=s+', CB_'+EListField.Items[t];
      end;
      s:=s+')';
      add(s);


      s:='  sqltext = "select '+EListField.Items[0]+'"';
      add(s);
      for t:=1 to EListField.Items.Count-1 do
      begin
        if EListField.Checked[t] then
          add('  if CB_'+EListField.Items[t]+'="Y" then sqltext=sqltext & ", '+EListField.Items[t]+'"');
      end;
      s:='  sqltext=sqltext & " from '+elisttbl.Items[elisttbl.itemindex]+' where 1=1 "';
      add(s);

      for t:=0 to EListField.Items.Count-1 do
      begin
        s:='';
        s:=s+'  if R_'+EListField.Items[t]+'<>"" then';
        add(s);
        s:='';
        if (pos('string',elisttype.Items[t])>0) then s:=s+'    sqltext = sqltext & " and '+EListField.Items[t]+'=''" & PrepareField(R_'+EListField.Items[t]+') & "''"'
        else if (pos('date',elisttype.Items[t])>0) then
            begin
              if pos('JET',uppercase(econnstr.Text))>0 then
                s:=s+'    sqltext = sqltext & " and '+EListField.Items[t]+'=''#" & PrepareField(R_'+EListField.Items[t]+') & "#''"'
              else
                s:=s+'    sqltext = sqltext & " and '+EListField.Items[t]+'=''" & PrepareField(R_'+EListField.Items[t]+') & "''"';
            end
            else s:=s+'    sqltext = sqltext & " and '+EListField.Items[t]+'=" & R_'+EListField.Items[t];
        add(s);
        s:='  end if';
        add(s);
      end;

      add('  if orddesc<>"" then');
      add('    sqltext = sqltext & " order by " & orddesc & " desc"');
      add('  else');
      add('    sqltext = sqltext & " order by " & ordinamento');
      add('  end if');

      add('  set ds = Server.CreateObject("ADODB.RecordSet")');
      add('  ds.CursorLocation = adUseClient');
      add('  ds.Open sqltext, DB, adOpenStatic, adLockReadOnly, adCmdText');

      add('  if err.number<>0 then response.write "ERRORE n." & err.number & "<br>" & err.description & "<br>SQL Error<br> " & sqltext');
      add('  Set RetreiveData = ds');
      add('End Function');
      add('''------------------------------------------------------------------------------------------------------------------''');
  end;
end;

procedure TForm1.GenNavigator;
var t:integer;
    s:string;
begin
  with memo1.Lines do
  begin
      add('''------------------------------------------------------------------------------------------------------------------''');
      s:='Sub DisplayNavigation(db, ds, pn, ordinamento, orddesc, R_'+EListField.Items[0];
      for t:=1 to EListField.Items.Count-1 do
      begin
        s:=s+', R_'+EListField.Items[t];
      end;
      s:=s+',nrecpp)';
      add(s);

      s:='  response.write "<form name=NAV id=NAV><table';
      if FOption.ebordo.Checked then s:=s+' border=1 cellspacing='+FOption.ECellspacing.Text+' cellpadding='+FOption.ECellpadding.Text;
      s:=s+'>" & vbCRLF';
      add(s);
      add('  response.write "<tr valign=bottom>" & vbCRLF');
      add('  response.write "<td>RecCount:" & ds.recordcount & "</td>"');
      add('  response.write "<td>"');
      add('  response.write "Page <input type=text name=pn value=""" & pn & """ size=2> of "& ds.pagecount & vbCRLF');
      add('  response.write "<input type=hidden name=""ordinamento"" value=""" & ordinamento & """>" & vbCRLF');
      add('  response.write "<input type=hidden name=""orddesc"" value=""" & orddesc & """>" & vbCRLF');
      add('  response.write "<input type=hidden name=""nrecpp"" value=""" & nrecpp & """>" & vbCRLF');


      for t:=1 to EListField.Items.Count-1 do
      begin
        add('  response.write "<input type=hidden name=""R_'+EListField.Items[t]+'"" value=""" & R_'+EListField.Items[t]+' & """>" & vbCRLF');
      end;


      add('  response.write "<td align=""right"">"');
      add('  if pn > 1 then');
      //add('    response.write "<a href="""& request.servervariables("PATH_INFO") &"?pn=" & pn - 1 & "&ordinamento=" & ordinamento & """>&lt;&lt;</a>&nbsp;&nbsp;&nbsp;"');
      if foption.EPriorIcon.Text='' then
        add('    response.write "<a href=""javascript:SbmForm(''" & ordinamento & "'',''" & orddesc & "'',''" & pn - 1 & "'');"">Prior</a>" & vbCRLF')
      else
        add('    response.write "<img onclick=""return SbmForm(''" & ordinamento & "'',''" & orddesc & "'',''" & pn - 1 & "'');"" src=""Prior.gif"">" & vbCRLF');


      add('  end if');
      add('  if pn < ds.PageCount then');
      //add('    response.write "<a href="""& request.servervariables("PATH_INFO") &"?pn=" & pn + 1 & "&ordinamento=" & ordinamento & """>&gt;&gt;</a>&nbsp;&nbsp;&nbsp;"');
      if foption.ENextIcon.Text='' then
        add('    response.write "<a href=""javascript:SbmForm(''" & ordinamento & "'',''" & orddesc & "'',''" & pn + 1 & "'');"">Next</a>" & vbCRLF')
      else
        add('    response.write "<img onclick=""return SbmForm(''" & ordinamento & "'',''" & orddesc & "'',''" & pn + 1 & "'');"" src=""Next.gif"">" & vbCRLF');
      add('  end if');

      add('  response.write "</td>" & vbCRLF');
      add('  response.write "</tr>" & vbCRLF');
      add('  response.write "</table>" & vbCRLF');
      add('  response.write "</form>"& vbCRLF');
      add('End Sub');
      add('''------------------------------------------------------------------------------------------------------------------''');
  end;
end;

procedure TForm1.GenDisplayData;
var t:integer;
    s:string;
    procedure InsNew;
    begin
      with memo1.Lines do
      begin
        if FOption.einsrec.Checked then
        begin
          if FOption.ENewIcon.Text<>'' then
            add('  response.write "<a href=""" & request.servervariables("PATH_INFO") & "?nuovo=yes""><img src=""'+FOption.ENewIcon.Text+'"" border=0></a>" & vbCRLF')
          else
            add('  response.write "<a href=""" & request.servervariables("PATH_INFO") & "?nuovo=yes"">New</a>" & vbCRLF');
        end;
      end;
    end;

    procedure InsNav;
    var t:integer;
    begin
      with memo1.Lines do
      begin
        s:='  DisplayNavigation db, ds, pn, ordinamento, orddesc, R_'+EListField.Items[0];
        for t:=1 to EListField.Items.Count-1 do
        begin
          s:=s+', R_'+EListField.Items[t];
        end;
        s:=s+',nrecpp';
        add(s);
      end;
    end;


begin
  with memo1.Lines do
  begin
      add('''------------------------------------------------------------------------------------------------------------------''');
      s:='Sub DisplayData(db, ds, pn, ordinamento, orddesc, R_'+EListField.Items[0];
      for t:=1 to EListField.Items.Count-1 do
      begin
        s:=s+', R_'+EListField.Items[t];
      end;
      s:=s+',nrecpp)';
      add(s);


      if foption.ENavPos.Text='Top Left' then
      begin
        add('  response.write "<div align=left>" & vbCRLF');
        InsNav;
        add('  response.write "</div>" & vbCRLF');
      end;
      if foption.ENavPos.Text='Top Center' then
      begin
        add('  response.write "<div align=center>" & vbCRLF');
        InsNav;
        add('  response.write "</div>" & vbCRLF');
      end;
      if foption.ENavPos.Text='Top Right' then
      begin
        add('  response.write "<div align=Right>" & vbCRLF');
        InsNav;
        add('  response.write "</div>" & vbCRLF');
      end;

      s:='  response.write "<table';
      if FOption.ebordo.Checked then s:=s+' border=1 cellspacing='+FOption.ECellspacing.Text+' cellpadding='+FOption.ECellpadding.Text;
      s:=s+' width=""'+inttostr(FOption.etabdim.value)+'%"">" & vbCRLF';
      add(s);

      if foption.enewpos.Text='Top Left' then
      begin
        add('  response.write "<thead>" & vbCRLF');
        InsNew;
        add('  response.write "</thead>" & vbCRLF');
      end;
      if foption.enewpos.Text='Top Center' then
      begin
        add('  response.write "<caption>" & vbCRLF');
        InsNew;
        add('  response.write "</caption>" & vbCRLF');
      end;
      if foption.enewpos.Text='Top Right' then
      begin
        add('  response.write "<tr><td align=right>" & vbCRLF');
        InsNew;
        add('  response.write "</td></tr>" & vbCRLF');
      end;

      add('  response.write "<tr style=""BACKGROUND-COLOR:#'+FOption.ETitleColor.Text+';color:white;"">" & vbCRLF');
      if FOption.emodrec.Checked then
      begin
        add('  response.write "<th>&nbsp;</th>" & vbCRLF');
      end;
      add('  for t=1 to ds.fields.count-1');

      (*s:='    response.write "<th><a href=""" & request.servervariables("PATH_INFO") & "?ordinamento=" & t+1 & "&R_'+EListField.Items[0]+'=" & R_'+EListField.Items[0]+' & "';
      for t:=1 to EListField.Items.Count-1 do
      begin
        s:=s+'&R_'+EListField.Items[t]+'=" & R_'+EListField.Items[t]+' & "';
      end;
      s:=s+'"">" & ds.fields.item(t).name & "</a></th>" & vbCRLF';*)
      if foption.ESortIcon.Text='' then
        s:='    response.write "<th><a href=""javascript:SbmForm(''" & t+1 & "'','''',''" & pn & "'');"">S</a> " & ds.fields.item(t).name'
      else
        s:='    response.write "<th><img onclick=""return SbmForm(''" & t+1 & "'','''',''" & pn & "'');"" src=""'+foption.ESortIcon.Text+'""> " & ds.fields.item(t).name';
      add(s);

      if foption.ESortDesc.Text='' then
        s:='    response.write " <a href=""javascript:SbmForm('''',''" & t+1 & "'',''" & pn & "'');"">D</a></th>" & vbCRLF'
      else
        s:='    response.write " <img onclick=""return SbmForm('''',''" & t+1 & "'',''" & pn & "'');"" src=""'+foption.ESortDesc.Text+'""></th>" & vbCRLF';
      add(s);

      add('  next');
      if FOption.edelrec.Checked then
        add('  response.write "<th>&nbsp;</th>" & vbCRLF');
      add('  response.write "</tr>" & vbCRLF');

      add('  if not(ds.eof) then');
      add('    ds.AbsolutePage = pn');
      add('    for intCount = 1 to ds.PageSize');

      add('    response.write "<tr style=""" & FlipRowStyle(IsOdd, "clsOdd", "clsPair") & """>" & vbCRLF');
      if FOption.emodrec.Checked then
        if FOption.EEditIcon.Text<>'' then
          add('    response.write "<td><a href=""" & request.servervariables("PATH_INFO") & "?'+EListField.Items[0]+'=" & ds.fields.item(0).value & "&modifica=yes""><img src=""'+FOption.EEditIcon.Text+'"" border=0></a></td>" & vbCRLF')
        else
          add('    response.write "<td><a href=""" & request.servervariables("PATH_INFO") & "?'+EListField.Items[0]+'=" & ds.fields.item(0).value & "&modifica=yes"">Edit</a></td>" & vbCRLF');
      add('    for t=1 to ds.fields.count-1');
      add('      if (isnull(ds.fields.item(t).value)) or (trim(ds.fields.item(t).value)="") then');
      add('        response.write "<td>&nbsp;</td>" & vbCRLF');
      add('      else');
      add('      	 response.write "<td>" & ds.fields.item(t).value & "</td>" & vbCRLF');
      add('      end if');
      add('    next');
      if FOption.edelrec.Checked then
        if FOption.EDelIcon.Text<>'' then
          add('    response.write "<td><a href=""" & request.servervariables("PATH_INFO") & "?'+EListField.Items[0]+'=" & ds.fields.item(0).value & "&elimina=yes""><img src=""'+FOption.EDelIcon.Text+'"" border=0></a></td>" & vbCRLF')
        else
          add('    response.write "<td><a href=""" & request.servervariables("PATH_INFO") & "?'+EListField.Items[0]+'=" & ds.fields.item(0).value & "&elimina=yes"">Del</a></td>" & vbCRLF');
      add('    response.write "</tr>" & vbCRLF');
      add('    ds.movenext');

      add('    if ds.EOF then exit for');
      add('    next');
      add('  end if');


      add('  response.write "</table>" & vbCRLF');

      if foption.ENavPos.Text='Bottom Left' then
      begin
        add('   response.write "<div align=left>" & vbCRLF');
        InsNav;
        add('   response.write "</div>" & vbCRLF');
      end;
      if foption.ENavPos.Text='Bottom Center' then
      begin
        add('   response.write "<div align=center>" & vbCRLF');
        InsNav;
        add('   response.write "</div>" & vbCRLF');
      end;
      if foption.ENavPos.Text='Bottom Right' then
      begin
        add('   response.write "<div align=Right>" & vbCRLF');
        InsNav;
        add('   response.write "</div>" & vbCRLF');
      end;



      add('End Sub');
      add('''------------------------------------------------------------------------------------------------------------------''');
  end;
end;

procedure TForm1.GenMain;
var t:integer;
    s:string;
begin
  with memo1.Lines do
  begin
      add('''------------------------------------------------------------------------------------------------------------------''');
      add('Sub Main()');
      if FOption.egesterr.Checked then add('  on error resume next');
      if FOption.estylesheet.Text<>'' then
        add('  response.write "<LINK rel=stylesheet href=""'+ FOption.estylesheet.Text + '"">" & vbCRLF');
      if FOption.ecenter.Checked then
        add('  response.write "<center>" & vbCRLF');
      add('  nuovo = request("nuovo")');
      add('  nuovoi = request("nuovoi")');
      add('  modifica = request("modifica")');
      add('  modificai = request("modificai")');
      add('  elimina = request("elimina")');
      add('  ordinamento = request("ordinamento")');
      add('  orddesc = request("orddesc")');
      add('  nrecpp = request("nrecpp")');
      add('  if nrecpp="" then nrecpp="'+foption.erecpag.Text+'"');
      add('  if ordinamento = "" then ordinamento="1"');
      for t:=0 to EListField.Items.Count-1 do
      begin
        add('  '+EListField.Items[t]+' = request("'+EListField.Items[t]+'")');
      end;
      for t:=0 to EListField.Items.Count-1 do
      begin
        add('  R_'+EListField.Items[t]+' = request("R_'+EListField.Items[t]+'")');
      end;
      for t:=0 to EListField.Items.Count-1 do
      begin
        add('  N_'+EListField.Items[t]+' = request("N_'+EListField.Items[t]+'")');
      end;
      for t:=0 to EListField.Items.Count-1 do
      begin
        add('  E_'+EListField.Items[t]+' = request("E_'+EListField.Items[t]+'")');
      end;
      for t:=0 to EListField.Items.Count-1 do
      begin
        add('  CB_'+EListField.Items[t]+' = request("CB_'+EListField.Items[t]+'")');
      end;
      add('  searchok = request("searchok")');
      add('  if searchok="" then ');
      for t:=0 to EListField.Items.Count-1 do
      begin
        add('  CB_'+EListField.Items[t]+' = "Y"');
      end;
      add('  end if');


      add('  fatto="no"');
      add('  set DB = OpenDataBase()');

      add('  if (nuovo="yes") then');
      add('    call Form_Nuovo()');
      add('    fatto="si"');
      add('  end if');

      add('  if (nuovoi="yes") then');
      s:='    call SubInsert(db, N_'+EListField.Items[0];
      for t:=1 to EListField.Items.Count-1 do
      begin
        s:=s+', N_'+EListField.Items[t];
      end;
      s:=s+')';
      add(s);
      add('    fatto="si"');
      add('  end if');

      add('  if (modifica="yes") then');
      add('    call Form_Edit(db, '+EListField.Items[0]+')');
      add('    fatto="si"');
      add('  end if');

      add('  if (modificai="yes") then');
      s:='    call SubUpdate(db, E_'+EListField.Items[0];
      for t:=1 to EListField.Items.Count-1 do
      begin
        s:=s+', E_'+EListField.Items[t];
      end;
      s:=s+')';
      add(s);
      add('    fatto="si"');
      add('  end if');

      add('  if elimina<>"" then');
      add('    call SubDelete(db, '+EListField.Items[0]+')');
      add('    fatto="si"');
      add('  end if');


      add('  if fatto="no" then');

      if foption.EDisplayTitle.checked then
        add('    response.write "<H1>'+elisttbl.Items[elisttbl.itemindex]+'</H1>" & vbCRLF');
      if foption.EDisplayHR.Checked then
        add('    response.write "<hr>" & vbCRLF');
      add('    if Request("pn")<>"" then');
      add('      pn = CInt(Request("pn"))');
      add('    else');
      add('      pn = 1');
      add('    end if');

      s:='    set ds = RetreiveData(db, ordinamento, orddesc, R_'+EListField.Items[0];
      for t:=1 to EListField.Items.Count-1 do
      begin
        s:=s+', R_'+EListField.Items[t];
      end;
      s:=s+',nrecpp,CB_'+EListField.Items[0];
      for t:=1 to EListField.Items.Count-1 do
      begin
        s:=s+', CB_'+EListField.Items[t];
      end;
      s:=s+')';
      add(s);

      add('    if pn>ds.pagecount then');
      add('      pn= ds.pagecount');
      add('    end if');


      s:='    call Intestazione(db,pn,ordinamento,orddesc,R_'+EListField.Items[0];
      for t:=1 to EListField.Items.Count-1 do
      begin
        s:=s+', R_'+EListField.Items[t];
      end;
      s:=s+',nrecpp,CB_'+EListField.Items[0];
      for t:=1 to EListField.Items.Count-1 do
      begin
        s:=s+', CB_'+EListField.Items[t];
      end;
      s:=s+')';


      if FOption.esearch.Checked then add(s);


      add('    ds.PageSize = nrecpp');

      s:='    DisplayData db, ds, pn, ordinamento, orddesc, R_'+EListField.Items[0];
      for t:=1 to EListField.Items.Count-1 do
      begin
        s:=s+', R_'+EListField.Items[t];
      end;
      s:=s+',nrecpp';
      add(s);


      add('    Ds.close');
      add('    set Ds=Nothing');
      add('  end if');
      add('  DB.close');
      add('  set DB=Nothing');
      if FOption.ecenter.Checked then
        add('  response.write "</center>" & vbCRLF');
      add('End Sub');
      add('''------------------------------------------------------------------------------------------------------------------''');
  end;
end;



procedure TForm1.AAspGenExecute(Sender: TObject);
var t:integer;
    s:string;
begin
  if not(ado1.Connected) or (elistfield.Items.Count=0) then
  begin
    showmessage('Cannot generate ASP');
  end
  else
  begin
    //CONTROLLO ESISTENZA DEL FILE ADOVBS.INC
    s:=foption.ESSI1.Text;
    while pos('/',s)>0 do
      s[pos('/',s)]:='\';
    s:=foption.EWebSrvPath.Text+s;
    if not(fileexists(s)) then
    begin
      showmessage(s+' does not exists. Can''t generate ASP.');
      exit;
    end;
    screen.Cursor:=crhourglass;
    if foption.EProgress.Checked then FInfoPrj.show;
    FInfoPrj.StaticText1.Caption:='Project '+statusbar1.Panels[0].text;
    FInfoPrj.StaticText2.Caption:='Generating ASP code ...';
    FInfoPrj.StaticText3.Caption:='Total lines';
    FInfoPrj.ProgressBar1.Max:=11;
    FInfoPrj.ProgressBar1.Position:=0;
    FInfoPrj.Repaint;
    memo1.clear;
    GenInit;
    FInfoPrj.ProgressBar1.Position:=1;
    FInfoPrj.Repaint;
    GenSearchForm;
    FInfoPrj.ProgressBar1.Position:=2;
    FInfoPrj.Repaint;
    GenNewForm;
    FInfoPrj.ProgressBar1.Position:=3;
    FInfoPrj.Repaint;
    GenSubInsert;
    FInfoPrj.ProgressBar1.Position:=4;
    FInfoPrj.Repaint;
    GenEditForm;
    FInfoPrj.ProgressBar1.Position:=5;
    FInfoPrj.Repaint;
    GenSubUpdate;
    FInfoPrj.ProgressBar1.Position:=6;
    FInfoPrj.Repaint;
    GenSubDelete;
    FInfoPrj.ProgressBar1.Position:=7;
    FInfoPrj.Repaint;
    GenRetreiveData;
    FInfoPrj.ProgressBar1.Position:=8;
    FInfoPrj.Repaint;
    GenNavigator;
    FInfoPrj.ProgressBar1.Position:=9;
    FInfoPrj.Repaint;
    GenDisplayData;
    FInfoPrj.ProgressBar1.Position:=10;
    FInfoPrj.Repaint;
    GenMain;
    FInfoPrj.ProgressBar1.Position:=11;
    FInfoPrj.Repaint;
    with memo1.Lines do
    begin
      add('Call Main');
      add('%>');
      for t:=0 to foption.EHTMLFooter.Lines.Count-1 do
      begin
        add(foption.EHTMLFooter.Lines[t]);
      end;
      Add('</HTML>');
    end;
    screen.Cursor:=crdefault;
    FInfoPrj.StaticText2.Caption:='Done.';
    FInfoPrj.StaticText3.Caption:='Total lines '+inttostr(memo1.lines.Count);
    //pagecontrol1.ActivePage:=tabsheet3;
    //activecontrol:=memo1;
  end;
end;

procedure TForm1.EListTblClick(Sender: TObject);
var t:integer;
    appo:string;
begin
  screen.cursor:=crhourglass;
  ado1.GetFieldNames(elisttbl.Items[elisttbl.itemindex],EListField.Items);
  tbl1.Close;
  tbl1.TableName:=elisttbl.Items[elisttbl.itemindex];
  tbl1.open;
  elisttype.Clear;
  appo:='';
  for t:=0 to elistfield.Count-1 do
  begin
    EListField.Checked[t]:=true;
    if tbl1.Fieldbyname(elistfield.Items[t]).DataType in [ftstring,ftdate,ftdatetime,ftmemo,ftfixedchar,ftwidestring] then
      elisttype.Items.Add(tbl1.Fieldbyname(elistfield.Items[t]).FieldName+' - string')
    else if tbl1.Fieldbyname(elistfield.Items[t]).DataType in [ftsmallint,ftinteger,ftautoinc,ftlargeint] then
      elisttype.Items.Add(tbl1.Fieldbyname(elistfield.Items[t]).FieldName+' - number')
    else if tbl1.Fieldbyname(elistfield.Items[t]).DataType in [ftboolean] then
      elisttype.Items.Add(tbl1.Fieldbyname(elistfield.Items[t]).FieldName+' - boolean')
    else
      elisttype.Items.Add(tbl1.Fieldbyname(elistfield.Items[t]).FieldName+' - unknown');
  end;
(*  for t:=0 to tbl1.FieldCount-1 do
  begin
    EListField.Checked[t]:=true;
    if tbl1.Fields[t].DataType in [ftstring,ftdate,ftdatetime,ftmemo,ftfixedchar,ftwidestring] then
      elisttype.Items.Add(tbl1.Fields[t].FieldName+' - string')
    else if tbl1.Fields[t].DataType in [ftsmallint,ftinteger,ftautoinc,ftlargeint] then
      elisttype.Items.Add(tbl1.Fields[t].FieldName+' - number')
    else if tbl1.Fields[t].DataType in [ftboolean] then
      elisttype.Items.Add(tbl1.Fields[t].FieldName+' - boolean')
    else
      elisttype.Items.Add(tbl1.Fields[t].FieldName+' - unknown');
  end;
*)
  tbl1.GetIndexNames(EListIndex.Items);

  if EListIndex.Count=0 then
  begin
    linfo.caption:='Cannot generate ASP Page on table without primary key.';
  end
  else
  begin
    tbl1.Close;
    tbl1.IndexName:=EListIndex.Items[0];
    tbl1.open;
    appo:='';
    for t:=0 to tbl1.FieldCount-1 do
    begin
      if tbl1.Fields[t].IsIndexField then appo:=tbl1.Fields[t].DisplayName;
    end;
    linfo.caption:='Move primary key '+appo+' to first place and generate the ASP page.';
    aaspgen.Enabled:=true;
  end;

  aaspgen.Enabled:=true;
  screen.cursor:=crdefault;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  if tag=0 then
  begin
    pagecontrol1.visible:=false;
    aconnstr.Enabled:=false;
    ASalvaImp.enabled:=false;
    AOption.enabled:=false;
    ATestPage.enabled:=false;
    ADO1AfterDisconnect(sender);
    tag:=1;
  end;
end;

procedure TForm1.Esci1Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.leggiIni(nomefile:string);
var VAGFile: TIniFile;
    t:integer;
    s:string;
begin
    VAGFile := TIniFile.Create(nomefile);
    with VAGFile do
    begin
      econnstr.Text := ReadString(application.Title, 'ConnStr', 'Provider=SQLOLEDB.1;Persist Security Info=False;User ID=sa;password=sa;Initial Catalog=Intranet;Data Source=vosoft');
      FOption.einsrec.Checked:= (ReadString(application.Title, 'InsRec', 'TRUE') = 'TRUE');
      FOption.emodrec.Checked:= (ReadString(application.Title, 'ModRec', 'TRUE') = 'TRUE');
      FOption.edelrec.Checked:= (ReadString(application.Title, 'DelRec', 'TRUE') = 'TRUE');
      FOption.esearch.Checked:= (ReadString(application.Title, 'Search', 'TRUE') = 'TRUE');
      FOption.egesterr.Checked:= (ReadString(application.Title, 'GestErr', 'TRUE') = 'TRUE');
      FOption.EProgress.Checked:= (ReadString(application.Title, 'Progress', 'TRUE') = 'TRUE');
      FOption.ebordo.Checked:= (ReadString(application.Title, 'Bordo', 'TRUE') = 'TRUE');
      FOption.ecenter.Checked:= (ReadString(application.Title, 'Center', 'TRUE') = 'TRUE');
      FOption.ewebsrvpath.Text := ReadString(application.Title, 'WebSrvPath', 'd:\inetpub\wwwroot');
      FOption.etabdim.Value := strtoint(ReadString(application.Title, 'ETabDim', '100'));
      FOption.ecellspacing.Value := strtoint(ReadString(application.Title, 'ECellSpacing', '0'));
      FOption.ecellpadding.Value := strtoint(ReadString(application.Title, 'ECellPadding', '0'));
      FOption.eRecPag.Value := strtoint(ReadString(application.Title, 'ERecPag', '10'));
      FOption.estylesheet.Text := ReadString(application.Title, 'StyleSheet', '/css/intra.css');
      FOption.enewicon.Text := ReadString(application.Title, 'NewIcon', '');
      FOption.eediticon.Text := ReadString(application.Title, 'EditIcon', '');
      FOption.edelicon.Text := ReadString(application.Title, 'DelIcon', '');
      FOption.esorticon.Text := ReadString(application.Title, 'SortIcon', '');
      FOption.ESortDesc.Text := ReadString(application.Title, 'SortDesc', '');
      FOption.enexticon.Text := ReadString(application.Title, 'NextIcon', '');
      FOption.eprioricon.Text := ReadString(application.Title, 'PriorIcon', '');
      FOption.essi1.Text := ReadString(application.Title, 'SSI1', '/adovbs.inc');
      FOption.essi2.Text := ReadString(application.Title, 'SSI2', '');
      FOption.essi3.Text := ReadString(application.Title, 'SSI3', '');
      FOption.essi4.Text := ReadString(application.Title, 'SSI4', '');

      FOption.EDisplayTitle.Checked:= (ReadString(application.Title, 'DisplayTitle', 'TRUE') = 'TRUE');
      FOption.EDisplayHR.Checked:= (ReadString(application.Title, 'DisplayHR', 'TRUE') = 'TRUE');
      FOption.ENavPos.Text := ReadString(application.Title, 'NavPos', 'TopLeft');
      FOption.ENewPos.Text := ReadString(application.Title, 'NewPos', 'TopLeft');

      FOption.ETitleColor.Text := ReadString(application.Title, 'TitleColor', '000000');
      FOption.EPairColor.Text := ReadString(application.Title, 'PairColor', 'FFFFFF');
      FOption.EOddColor.Text := ReadString(application.Title, 'OddColor', 'FFFFFF');

      FOption.EHTMLFooter.Clear;
      for t:=0 to strtoint(ReadString(application.Title, 'NumHTMLFooter', '0')) do
      begin
        FOption.EHTMLFooter.Lines.Add(ReadString(application.Title, 'HTMLFooter'+inttostr(t), ''))
      end;
    end;
    VAGFile.Free;
end;

procedure TForm1.AApriImpExecute(Sender: TObject);
begin
  if vagopen.Execute then
  begin
    pagecontrol1.Visible:=true;
    pagecontrol1.ActivePageIndex:=1;
    leggiIni(vagopen.FileName);
    statusbar1.Panels[0].Text:=vagopen.FileName;
    ASalvaImp.enabled:=true;
    aconnstr.Enabled:=true;
    aoption.Enabled:=true;
    memo1.lines.Clear;
  end;
end;

procedure TForm1.ScriviIni(nomefile:string);
var VAGFile: TIniFile;
    t:integer;
begin
    VAGFile := TIniFile.Create(vagsave.filename);
    with VAGFile do
    begin
      writeString(application.Title, 'ConnStr', econnstr.Text);
      if FOption.einsrec.Checked then WriteString(application.Title, 'InsRec', 'TRUE')
                         else  WriteString(application.Title, 'InsRec', 'FALSE');
      if FOption.emodrec.Checked then WriteString(application.Title, 'ModRec', 'TRUE')
                         else  WriteString(application.Title, 'ModRec', 'FALSE');
      if FOption.edelrec.Checked then WriteString(application.Title, 'DelRec', 'TRUE')
                         else  WriteString(application.Title, 'DelRec', 'FALSE');
      if FOption.esearch.Checked then WriteString(application.Title, 'Search', 'TRUE')
                         else  WriteString(application.Title, 'Search', 'FALSE');
      if FOption.egesterr.Checked then WriteString(application.Title, 'GestErr', 'TRUE')
                         else  WriteString(application.Title, 'GestErr', 'FALSE');
      if FOption.EProgress.Checked then WriteString(application.Title, 'Progress', 'TRUE')
                         else  WriteString(application.Title, 'Progress', 'FALSE');
      if FOption.ebordo.Checked then WriteString(application.Title, 'Bordo', 'TRUE')
                         else  WriteString(application.Title, 'Bordo', 'FALSE');
      if FOption.ecenter.Checked then WriteString(application.Title, 'Center', 'TRUE')
                         else  WriteString(application.Title, 'Center', 'FALSE');
      WriteString(application.Title, 'WebSrvPath', FOption.ewebsrvpath.Text);
      WriteString(application.Title, 'ETabDim', inttostr(FOption.etabdim.Value));
      WriteString(application.Title, 'ECellSpacing', inttostr(FOption.ecellspacing.Value));
      WriteString(application.Title, 'ECellPadding', inttostr(FOption.ecellpadding.Value));
      WriteString(application.Title, 'ERecPag', inttostr(FOption.erecPag.Value));
      WriteString(application.Title, 'StyleSheet', FOption.estylesheet.Text);
      WriteString(application.Title, 'NewIcon', FOption.enewicon.Text);
      WriteString(application.Title, 'EditIcon', FOption.eediticon.Text);
      WriteString(application.Title, 'DelIcon', FOption.edelicon.Text);
      WriteString(application.Title, 'SortIcon', FOption.esorticon.Text);
      WriteString(application.Title, 'SortDesc', FOption.esortdesc.Text);
      WriteString(application.Title, 'NextIcon', FOption.enexticon.Text);
      WriteString(application.Title, 'PriorIcon', FOption.eprioricon.Text);
      WriteString(application.Title, 'SSI1', FOption.essi1.Text);
      WriteString(application.Title, 'SSI2', FOption.essi2.Text);
      WriteString(application.Title, 'SSI3', FOption.essi3.Text);
      WriteString(application.Title, 'SSI4', FOption.essi4.Text);

      WriteString(application.Title, 'TitleColor', FOption.ETitleColor.Text);
      WriteString(application.Title, 'PairColor', FOption.EPairColor.Text);
      WriteString(application.Title, 'OddColor', FOption.EOddColor.Text);

      if FOption.EDisplayTitle.Checked then WriteString(application.Title, 'DisplayTitle', 'TRUE')
                                       else WriteString(application.Title, 'DisplayTitle', 'FALSE');
      if FOption.EDisplayHR.Checked then WriteString(application.Title, 'DisplayHR', 'TRUE')
                                       else WriteString(application.Title, 'DisplayHR', 'FALSE');
      WriteString(application.Title, 'NavPos', FOption.ENavPos.Text);
      WriteString(application.Title, 'NewPos', FOption.ENewPos.Text);
      WriteString(application.Title, 'NumHTMLFooter', inttostr(FOption.EHTMLFooter.lines.count-1));
      for t:=0 to FOption.EHTMLFooter.lines.count-1 do
      begin
        WriteString(application.Title, 'HTMLFooter'+inttostr(t), FOption.EHTMLFooter.Lines[t]);
      end;


    end;
    VAGFile.Free;
end;

procedure TForm1.ASalvaImpExecute(Sender: TObject);
var VAGFile: TIniFile;
begin
  if vagsave.Execute then
  begin
    scriviIni(vagsave.FileName);
  end;
end;

procedure TForm1.ANewImpExecute(Sender: TObject);
begin
    pagecontrol1.Visible:=true;
    pagecontrol1.ActivePageIndex:=1;
    econnstr.Text := '';
    FOption.einsrec.Checked:= true;
    FOption.emodrec.Checked:= true;
    FOption.edelrec.Checked:= true;
    FOption.egesterr.Checked:= true;
    FOption.ebordo.Checked:= true;
    FOption.ewebsrvpath.Text := 'c:\inetpub\wwwroot';
    statusbar1.Panels[0].Text:='New Configuration File';
    ADO1AfterDisconnect(sender);
    ASalvaImp.enabled:=true;
    aconnstr.Enabled:=true;
    aoption.Enabled:=true;
    memo1.lines.Clear;
end;

procedure TForm1.ADO1AfterDisconnect(Sender: TObject);
begin
  panel3.Visible:=false;
  panel4.Visible:=false;
  memo1.Visible:=false;
  aaspgen.Enabled:=false;
  asavasp.Enabled:=false;
end;

procedure TForm1.ADO1AfterConnect(Sender: TObject);
begin
  panel3.visible:=true;
  panel4.visible:=true;
  memo1.Visible:=true;
//  aaspgen.Enabled:=true;
//  asavasp.Enabled:=true;
end;

procedure TForm1.ASavASPExecute(Sender: TObject);
begin
  if savedialog1.execute then
    memo1.Lines.SaveToFile(savedialog1.FileName);
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  AboutBox.Version.Caption:='Version '+versione;
  AboutBox.showmodal
end;

procedure TForm1.StopActionExecute(Sender: TObject);
begin
  WebBrowser1.Stop;
end;

procedure TForm1.WebBrowser1DownloadBegin(Sender: TObject);
begin
  { Play the avi from the first frame indefinitely }
  screen.Cursor:=crAppStart;
end;

procedure TForm1.WebBrowser1DownloadComplete(Sender: TObject);
begin
  { Stop the avi and show the first frame }
  screen.Cursor:=crdefault;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  FAdoVbs.ShowModal;
end;

procedure TForm1.ATestPageExecute(Sender: TObject);
var  Flags: OLEVariant;
begin
  pagecontrol1.ActivePageIndex:=2;
  memo1.Lines.SaveToFile(FOption.EWebSrvPath.text+'\test.asp');
  Flags := 0;
  WebBrowser1.Navigate(WideString('http://localhost/test.asp'), Flags, Flags, Flags, Flags);
end;

procedure TForm1.AOptionExecute(Sender: TObject);
begin
  if FOption.ShowModal=mrOk then asalvaimp.Execute
    else
    begin
      leggiIni(statusbar1.Panels[0].Text);
    end;
end;

procedure TForm1.Memo2Change(Sender: TObject);
begin
  atestpage.Enabled:= not(memo1.Lines.Count=0);
  asavasp.Enabled:= not(memo1.Lines.Count=0);
end;

procedure TForm1.SBUpClick(Sender: TObject);
var appo:string;
    indice:integer;
begin
  if elistfield.ItemIndex>0 then
  begin
    indice:=elistfield.ItemIndex;
    appo:=elistfield.Items[indice];
    elistfield.Items[indice]:=elistfield.Items[indice-1];
    elistfield.Items[indice-1]:=appo;

    //indice:=elisttype.ItemIndex;
    appo:=elisttype.Items[indice];
    elisttype.Items[indice]:=elisttype.Items[indice-1];
    elisttype.Items[indice-1]:=appo;

    elistfield.Selected[indice-1]:=true
  end;
end;

procedure TForm1.SBDownClick(Sender: TObject);
var appo:string;
    indice:integer;
begin
  if elistfield.ItemIndex<elistfield.Count-1 then
  begin
    indice:=elistfield.ItemIndex;
    appo:=elistfield.Items[indice];
    elistfield.Items[indice]:=elistfield.Items[indice+1];
    elistfield.Items[indice+1]:=appo;

    //indice:=elisttype.ItemIndex;
    appo:=elisttype.Items[indice];
    elisttype.Items[indice]:=elisttype.Items[indice+1];
    elisttype.Items[indice+1]:=appo;

    elistfield.Selected[indice+1]:=true
  end;
end;


procedure TForm1.UpdateCursorPos;
var
  CharPos: TPoint;
begin
  CharPos.Y := SendMessage(Memo1.Handle, EM_EXLINEFROMCHAR, 0,
    Memo1.SelStart);
  CharPos.X := (Memo1.SelStart -
    SendMessage(Memo1.Handle, EM_LINEINDEX, CharPos.Y, 0));
  Inc(CharPos.Y);
  Inc(CharPos.X);
  StatusBar1.Panels[1].Text := Format(sColRowInfo, [CharPos.Y, CharPos.X]);
end;

procedure TForm1.Memo1SelectionChange(Sender: TObject);
begin
  UpdateCursorPos
end;

procedure TForm1.ABuildCSExecute(Sender: TObject);
begin
  if FBuildCS.Showmodal=mrok then
    EConnStr.Text:=FBuildCS.ConnStr;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  FAdoVbs.showmodal;
end;

end.
